*TITLE1 "EXAMPLEK01.SAS--Region by Gender 3D power plots with 5 age groups,N,Delta,Power replay";

LIBNAME INOUT01 "..\DATA\";
FILENAME OUT01 ".\EXAMPLEK01.CGM";

PROC IML SYMSIZE=2000 WORKSIZE=2000;
%INCLUDE "..\IML\POWERLIB203.IML"/NOSOURCE2;

OPT_ON = {GG HF BOX UN TOTAL_N ORTHU NOPRINT};
OPT_OFF={WARN ALPHA};

USE INOUT01.P0104;
READ ALL VAR {ANT LEFT POST RIGHT} WHERE(_TYPE_ = "COV") INTO INSIGMA;

ALPHA = .05/6;
SIGMA = ROUND(INSIGMA,.0001);

ESSENCEX = I(10);
REPN = DO(1,10, 1);

P = 4;
Q = 2;
BETARG= J(2,4, 3.2) + {.30}#({ -1  0 1  0,
                               -1  0 1  0}) ;
BETASCAL={1};

C = {1 -1} @ J(1,5,1);

REGION = {1,2,3,4};
RUN UPOLY1(REGION,"REGION",U1,REGU);
U=U1;

DO DELTA=0 TO .20 BY .0008;
  BETARGD=BETARG + (J(2,2,0)||(DELTA//(-DELTA))||J(2,1,0));
  BETA= BETARGD @ J(5,1,1) ;
  RUN POWER;
  HOLDALL=HOLDALL//( _HOLDPOWER||J(NROW(_HOLDPOWER),1,DELTA) );
END;

NAME={"SIGSC" "BETASC" "N" "P_MULT" "EPS" "P_UN" "EXEPS_HF" "P_HF" "EXEPS_GG" "P_GG" "P_BOX" "DELTA"};
CREATE ONE FROM HOLDALL [COLNAME = NAME]; 
APPEND FROM HOLDALL;
CLOSE ONE;

DATA TWO;
N=100; DELTA=0; P_GG=0;		*Create 'dummy' entry for graph*;
RUN;

DATA INOUT01.EXK01;	*Dataset also used in EXAMPLEK02.SAS*;
SET ONE TWO;
KEEP N P_GG DELTA;
RUN;

*3D Power curves*;

%MACRO GRAPH(TILT,ROTATE);
PROC G3D DATA = THREE GOUT = FOUR;
	PLOT DELTA*N = P_GG/
		ZMIN=0 ZMAX=1.0 ZTICKNUM=6 YTICKNUM=5 XTICKNUM=5;
	LABEL P_GG = "Power";
RUN;
%MEND;

PROC G3GRID DATA = INOUT01.EXK01 OUT = THREE;
	GRID DELTA*N = P_GG/SPLINE NAXIS1=16 NAXIS2=11;
	
GOPTIONS GSFNAME=OUT01 DEVICE=CGMOF97P
CBACK=WHITE COLORS=(BLACK) HORIGIN=0IN VORIGIN=0IN
HSIZE=7IN VSIZE=5IN HTEXT=16PT FTEXT=ZAPF; 

%GRAPH(90,300);
RUN;QUIT;RUN;


%MACRO GRAPH(TILT,ROTATE);
PROC G3D DATA = THREE GOUT = FOUR;
	PLOT DELTA*P_GG = N/
		ZMIN=0 ZMAX=100 ZTICKNUM=6 YTICKNUM=5 XTICKNUM=6 SIDE;
	LABEL P_GG = "Power";
RUN;
%MEND;

PROC G3GRID DATA = INOUT01.EXK01 OUT = THREE;
	GRID DELTA*P_GG = N/SPLINE NAXIS1=16 NAXIS2=11;
	
GOPTIONS GSFNAME=OUT01 DEVICE=CGMOF97P
CBACK=WHITE COLORS=(BLACK) HORIGIN=0IN VORIGIN=0IN
HSIZE=7IN VSIZE=5IN HTEXT=16PT FTEXT=ZAPF;  

%GRAPH(90,300);
RUN;QUIT;RUN;


%MACRO GRAPH(TILT,ROTATE);
PROC G3D DATA = THREE GOUT = FOUR;
	PLOT N*P_GG = DELTA/
		ZMIN=0 ZMAX=0.2 ZTICKNUM=5 YTICKNUM=5 XTICKNUM=6 SIDE;
	LABEL P_GG = "Power";
RUN;
%MEND;

PROC G3GRID DATA = INOUT01.EXK01 OUT = THREE;
	GRID N*P_GG = DELTA/SPLINE NAXIS1=16 NAXIS2=11;
	
GOPTIONS GSFNAME=OUT01 DEVICE=CGMOF97P
CBACK=WHITE COLORS=(BLACK) HORIGIN=0IN VORIGIN=0IN
HSIZE=7IN VSIZE=5IN HTEXT=16PT FTEXT=ZAPF;  

%GRAPH(90,300);
RUN;QUIT;RUN;

PROC GREPLAY IGOUT=FOUR TC=TEMPCAT NOFS;
TDEF TEMP2BY2 DES="2 rows, 2 columns (3 plots)"
 1/LLX= 25 ULX= 25 LRX= 75 URX= 75   LLY=50 ULY=100 LRY=50 URY=100
 2/LLX= 0 ULX= 0 LRX= 50 URX= 50   LLY=0 ULY=50 LRY=0 URY=50
 3/LLX= 50 ULX= 50 LRX= 100 URX= 100   LLY=0 ULY=50 LRY=0 URY=50;
TEMPLATE TEMP2BY2;
TREPLAY 1:G3D  2:G3D1 3:G3D2;
RUN;QUIT; RUN;